Index: branches/1.3/gui/scripts/nanovisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4501)
+++ branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4504)
@@ -2074,15 +2002,15 @@
         array set info $vol
         set name $info(name)
-        if { ![info exists _settings($this-volume-$name)] } {
-            set _settings($this-volume-$name) $info(hide)
+        if { ![info exists _settings(-volumevisible-$name)] } {
+            set _settings(-volumevisible-$name) $info(hide)
         }
         checkbutton $inner.vol$row -text $info(label) \
-            -variable [itcl::scope _settings($this-volume-$name)] \
+            -variable [itcl::scope _settings(-volumevisible-$name)] \
             -onvalue 0 -offvalue 1 \
-            -command [itcl::code $this volume $key $name] \
+            -command [itcl::code $this ToggleVolume $key $name] \
             -font "Arial 9"
         Rappture::Tooltip::for $inner.vol$row $info(description)
         blt::table $inner $row,0 $inner.vol$row -anchor w 
-        if { !$_settings($this-volume-$name) } {
+        if { !$_settings(-volume-$name) } {
             $inner.vol$row select
         } 
@@ -2095,7 +2023,7 @@
 }
 
-itcl::body Rappture::NanovisViewer::volume { tag name } {
-    set bool $_settings($this-volume-$name)
-    SendCmd "volume statue $bool $name"
+itcl::body Rappture::NanovisViewer::ToggleVolume { tag name } {
+    set bool $_settings(-volumevisible-$name)
+    SendCmd "volume state $bool $name"
 }
 
@@ -2109,17 +2037,391 @@
         bottom "0.707107 0.707107 0 0"
     }
-    foreach name { qw qx qy qz } value $positions($side) {
+    foreach name { -qw -qx -qy -qz } value $positions($side) {
         set _view($name) $value
     } 
-    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    set q [ViewToQuaternion]
     $_arcball quaternion $q
     SendCmd "camera orient $q" 
     SendCmd "camera reset"
-    set _view(xpan) 0
-    set _view(ypan) 0
-    set _view(zoom) 1.0
-    set _settings($this-xpan) $_view(xpan)
-    set _settings($this-ypan) $_view(ypan)
-    set _settings($this-zoom) $_view(zoom)
-}
-
+    set _view(-xpan) 0
+    set _view(-ypan) 0
+    set _view(-zoom) 1.0
+    set _settings(-xpan) $_view(-xpan)
+    set _settings(-ypan) $_view(-ypan)
+    set _settings(-zoom) $_view(-zoom)
+}
+
+
+#
+# InitComponentSettings --
+#
+#       Initializes the volume settings for a specific component. This
+#       should match what's used as global settings above. This
+#       is called the first time we try to switch to a given component
+#       in SwitchComponent below.
+#
+itcl::body Rappture::NanovisViewer::InitComponentSettings { cname } { 
+    # Expanding component name for key.
+    array set _settings [subst {
+        $cname-ambient           60
+        $cname-colormap          default
+        $cname-diffuse           40
+        $cname-light2side        1
+        $cname-volumeopacity     0.5
+        $cname-specularexponent  90
+        $cname-specularlevel     30
+        $cname-thickness         350
+        $cname-volumevisible     1
+    }]
+}
+
+#
+# SwitchComponent --
+#
+#       This is called when the current component is changed by the
+#       dropdown menu in the volume tab.  It synchronizes the global
+#       volume settings with the settings of the new current component.
+#
+itcl::body Rappture::NanovisViewer::SwitchComponent { cname } { 
+    if { ![info exists _settings($cname-ambient)] } {
+        InitComponentSettings $cname
+    }
+    # _settings variables change widgets, except for colormap
+    set _settings(-ambient)          $_settings($cname-ambient)
+    set _settings(-colormap)         $_settings($cname-colormap)
+    set _settings(-diffuse)          $_settings($cname-diffuse)
+    set _settings(-light2side)       $_settings($cname-light2side)
+    set _settings(-specularexponent) $_settings($cname-specularexponent)
+    set _settings(-specularlevel)    $_settings($cname-specularlevel)
+    set _settings(-thickness)        $_settings($cname-thickness)
+    set _settings(-volumeopacity)    $_settings($cname-volumeopacity)
+    set _settings(-volumevisible)    $_settings($cname-volumevisible)
+    $itk_component(colormap) value   $_settings($cname-colormap)
+    set _current $cname;                # Reset the current component
+}
+
+#
+# BuildVolumeComponents --
+#
+#       This is called from the "scale" method which is called when a
+#       new dataset is added or deleted.  It repopulates the dropdown
+#       menu of volume component names.  It sets the current component
+#       to the first component in the list (of components found).
+#       Finally, if there is only one component, don't display the
+#       label or the combobox in the volume settings tab.
+#
+itcl::body Rappture::NanovisViewer::BuildVolumeComponents {} { 
+    $itk_component(volcomponents) choices delete 0 end
+    foreach name $_componentsList {
+        $itk_component(volcomponents) choices insert end $name $name
+    }
+    set _current [lindex $_componentsList 0]
+    $itk_component(volcomponents) value $_current
+    set parent [winfo parent $itk_component(volcomponents)]
+    if { [llength $_componentsList] <= 1 } {
+        # Unpack the components label and dropdown if there's only one
+        # component. 
+        blt::table forget $parent.volcomponents_l $parent.volcomponents
+    } else {
+        # Pack the components label and dropdown into the table there's 
+        # more than one component to select. 
+        blt::table $parent \
+            0,0 $parent.volcomponents_l -anchor e -cspan 2 \
+            0,2 $parent.volcomponents -cspan 3 -fill x 
+    }
+}
+
+#
+# GetDatasetsWithComponents --
+#
+#       Returns a list of all the datasets (known by the combination of
+#       their data object and component name) that match the given 
+#       component name.  For example, this is used where we want to change 
+#       the settings of volumes that have the current component.
+#
+itcl::body Rappture::NanovisViewer::GetDatasetsWithComponent { cname } { 
+    if { ![info exists _volcomponents($cname)] } {
+        return ""
+    }
+    set list ""
+    foreach tag $_volcomponents($cname) {
+        if { ![info exists _serverDatasets($tag)] } {
+            continue
+        }
+        lappend list $tag
+    }
+    return $list
+}
+
+#
+# HideAllMarkers --
+#
+#       Hide all the markers in all the transfer functions.  Can't simply 
+#       delete and recreate markers from the <style> since the user may 
+#       have create, deleted, or moved markers.
+#
+itcl::body Rappture::NanovisViewer::HideAllMarkers {} { 
+    foreach cname [array names _transferFunctionEditors] {
+        $_transferFunctionEditors($cname) hideMarkers 
+    }
+}
+
+itcl::body Rappture::NanovisViewer::GetColormap { cname color } { 
+    if { $color == "default" } {
+        return $_cname2defaultcolormap($cname)
+    }
+    return [ColorsToColormap $color]
+}
+
+itcl::body Rappture::NanovisViewer::GetAlphamap { cname name } { 
+    if { $name == "default" } {
+        return $_cname2defaultalphamap($cname)
+    }
+    return [NameToAlphamap $name]
+}
+
+itcl::body Rappture::NanovisViewer::ResetColormap { cname color } { 
+    # Get the current transfer function
+    if { ![info exists _cname2transferFunction($cname)] } {
+        return
+    }
+    foreach { cmap wmap } $_cname2transferFunction($cname) break
+    set cmap [GetColormap $cname $color]
+    set _cname2transferFunction($cname) [list $cmap $wmap]
+    SendCmd [list transfunc define $cname $cmap $wmap]
+    EventuallyRedrawLegend
+}
+
+itcl::body Rappture::NanovisViewer::ComputeAlphamap { cname } { 
+    if { ![info exists _transferFunctionEditors($cname)] } {
+        return [list 0.0 0.0 1.0 1.0]
+    }
+    if { ![info exists _settings($cname-ambient)] } {
+        InitComponentSettings $cname
+    }
+
+    set isovalues [$_transferFunctionEditors($cname) values]
+
+    # Currently using volume shading opacity to scale opacity in
+    # the volume shader. The transfer function always sets full
+    # opacity
+    set max 1.0
+
+    # Use the component-wise thickness setting from the slider
+    # settings widget
+    # Scale values between 0.00001 and 0.01000
+    set delta [expr {double($_settings($cname-thickness)) * 0.0001}]
+    
+    set first [lindex $isovalues 0]
+    set last [lindex $isovalues end]
+    set wmap ""
+    if { $first == "" || $first != 0.0 } {
+        lappend wmap 0.0 0.0
+    }
+    foreach x $isovalues {
+        set x1 [expr {$x-$delta-0.00001}]
+        set x2 [expr {$x-$delta}]
+        set x3 [expr {$x+$delta}]
+        set x4 [expr {$x+$delta+0.00001}]
+        if { $x1 < 0.0 } {
+            set x1 0.0
+        } elseif { $x1 > 1.0 } {
+            set x1 1.0
+        }
+        if { $x2 < 0.0 } {
+            set x2 0.0
+        } elseif { $x2 > 1.0 } {
+            set x2 1.0
+        }
+        if { $x3 < 0.0 } {
+            set x3 0.0
+        } elseif { $x3 > 1.0 } {
+            set x3 1.0
+        }
+        if { $x4 < 0.0 } {
+            set x4 0.0
+        } elseif { $x4 > 1.0 } {
+            set x4 1.0
+        }
+        # add spikes in the middle
+        lappend wmap $x1 0.0
+        lappend wmap $x2 $max
+        lappend wmap $x3 $max
+        lappend wmap $x4 0.0
+    }
+    if { $last == "" || $last != 1.0 } {
+        lappend wmap 1.0 0.0
+    }
+    return $wmap
+}
+
+
+itcl::body Rappture::NanovisViewer::NameToAlphamap { name } {
+    switch -- $name {
+        "ramp-up" {
+            set wmap { 
+                0.0 0.0 
+                1.0 1.0 
+            }
+        }
+        "ramp-down" {
+            set wmap { 
+                0.0 1.0 
+                1.0 0.0 
+            }
+        }
+        "vee" {
+            set wmap { 
+                0.0 1.0 
+                0.5 0.0 
+                1.0 1.0 
+            }
+        }
+        "tent-1" {
+            set wmap { 
+                0.0 0.0 
+                0.5 1.0 
+                1.0 0.0 
+            }
+        }
+        "tent-2" {
+            set wmap { 
+                0.0 0.0 
+                0.25 1.0 
+                0.5 0.0 
+                0.75 1.0 
+                1.0 0.0 
+            }
+        }
+        "tent-3" {
+            set wmap { 
+                0.0 0.0 
+                0.16666 1.0
+                0.33333 0.0
+                0.5     1.0
+                0.66666 0.0
+                0.83333 1.0
+                1.0 0.0 
+            }
+        }
+        "tent-4" {
+            set wmap { 
+                0.0     0.0 
+                0.125   1.0
+                0.25    0.0
+                0.375   1.0
+                0.5     0.0        
+                0.625   1.0
+                0.75    0.0
+                0.875   1.0
+                1.0     0.0 
+            }
+        }
+        "sinusoid-1" {
+            set wmap {
+                0.0                     0.000 0.600 0.800 
+                0.14285714285714285     0.400 0.900 1.000 
+                0.2857142857142857      0.600 1.000 1.000 
+                0.42857142857142855     0.800 1.000 1.000 
+                0.5714285714285714      0.900 0.900 0.900 
+                0.7142857142857143      0.600 0.600 0.600 
+                0.8571428571428571      0.400 0.400 0.400 
+                1.0                     0.200 0.200 0.200
+            }
+        }
+        "sinusoid-2" {
+            set wmap { 
+                0.0                     0.900 1.000 1.000 
+                0.1111111111111111      0.800 0.983 1.000 
+                0.2222222222222222      0.700 0.950 1.000 
+                0.3333333333333333      0.600 0.900 1.000 
+                0.4444444444444444      0.500 0.833 1.000 
+                0.5555555555555556      0.400 0.750 1.000 
+                0.6666666666666666      0.300 0.650 1.000 
+                0.7777777777777778      0.200 0.533 1.000 
+                0.8888888888888888      0.100 0.400 1.000 
+                1.0                     0.000 0.250 1.000
+            }
+        }
+        "sinusoid-6" {
+            set wmap {
+                0.0                             0.200   0.100   0.000 
+                0.09090909090909091             0.400   0.187   0.000 
+                0.18181818181818182             0.600   0.379   0.210 
+                0.2727272727272727              0.800   0.608   0.480 
+                0.36363636363636365             0.850   0.688   0.595 
+                0.45454545454545453             0.950   0.855   0.808 
+                0.5454545454545454              0.800   0.993   1.000 
+                0.6363636363636364              0.600   0.973   1.000 
+                0.7272727272727273              0.400   0.940   1.000 
+                0.8181818181818182              0.200   0.893   1.000 
+                0.9090909090909091              0.000   0.667   0.800 
+                1.0                             0.000   0.480   0.600 
+            }
+        }
+        "sinusoid-10" {
+            set wmap {
+                0.0                             0.000   0.480   0.600 
+                0.09090909090909091             0.000   0.667   0.800 
+                0.18181818181818182             0.200   0.893   1.000 
+                0.2727272727272727              0.400   0.940   1.000 
+                0.36363636363636365             0.600   0.973   1.000 
+                0.45454545454545453             0.800   0.993   1.000 
+                0.5454545454545454              0.950   0.855   0.808 
+                0.6363636363636364              0.850   0.688   0.595 
+                0.7272727272727273              0.800   0.608   0.480 
+                0.8181818181818182              0.600   0.379   0.210 
+                0.9090909090909091              0.400   0.187   0.000 
+                1.0                             0.200   0.100   0.000 
+            }
+        }
+        "step-2" {
+            set wmap {
+                0.0                             0.000   0.167   1.000
+                0.09090909090909091             0.100   0.400   1.000
+                0.18181818181818182             0.200   0.600   1.000
+                0.2727272727272727              0.400   0.800   1.000
+                0.36363636363636365             0.600   0.933   1.000
+                0.45454545454545453             0.800   1.000   1.000
+                0.5454545454545454              1.000   1.000   0.800
+                0.6363636363636364              1.000   0.933   0.600
+                0.7272727272727273              1.000   0.800   0.400
+                0.8181818181818182              1.000   0.600   0.200
+                0.9090909090909091              1.000   0.400   0.100
+                1.0                             1.000   0.167   0.000
+            }
+        }
+        "step-5" {
+            set wmap {
+                0.0                             1.000   0.167   0.000
+                0.09090909090909091             1.000   0.400   0.100
+                0.18181818181818182             1.000   0.600   0.200
+                0.2727272727272727              1.000   0.800   0.400
+                0.36363636363636365             1.000   0.933   0.600
+                0.45454545454545453             1.000   1.000   0.800
+                0.5454545454545454              0.800   1.000   1.000
+                0.6363636363636364              0.600   0.933   1.000
+                0.7272727272727273              0.400   0.800   1.000
+                0.8181818181818182              0.200   0.600   1.000
+                0.9090909090909091              0.100   0.400   1.000
+                1.0                             0.000   0.167   1.000
+            }
+        }
+        "step-12" {
+            set wmap {
+                "#EE82EE"
+                "#4B0082" 
+                "blue" 
+                "#008000" 
+                "yellow" 
+                "#FFA500" 
+                "red" 
+            }
+        }
+        default {
+        }
+    }
+    return ""
+}
+
+
Index: branches/1.3/gui/scripts/transferfunctioneditor.tcl
===================================================================
--- branches/1.3/gui/scripts/transferfunctioneditor.tcl	(revision 4504)
+++ branches/1.3/gui/scripts/transferfunctioneditor.tcl	(revision 4504)
@@ -0,0 +1,353 @@
+# -*- mode: tcl; indent-tabs-mode: nil -*- 
+
+# ----------------------------------------------------------------------
+#  COMPONENT: transferfunctioneditor - Rudimentary editor for 3D volume 
+#                                      transfer functions
+#
+#  This class is used to modify transfer functions used in volume rendering 
+#  on 3D scalar/vector datasets.
+#
+# ======================================================================
+#  AUTHOR:  Michael McLennan, Purdue University
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+# ======================================================================
+package require Itk
+package require BLT
+package require Img
+
+itcl::class Rappture::TransferFunctionEditor {
+    private variable _nextId 0;         # Used to create unique marker names
+    private variable _values;           # Relative values for each marker.
+    private variable _limits;           # Over limits of transfer function.
+    private variable _labels;           # Label id for each marker.
+    private variable _ticks;            # Tick id for each marker.
+    private variable _canvas    ""
+    private variable _name "";		# Name of transfer function.
+    private variable _activeMotion   0
+    private variable _activePress    0
+    private variable _id2name
+    private common   _normalIcon [Rappture::icon nvlegendmark]
+    private common   _activeIcon [Rappture::icon nvlegendmark2]
+    public variable command ""
+
+    private method SetAbsoluteValue { name x } 
+    private method GetAbsoluteValue { name } 
+    private method ContinueDrag { name x y } 
+    private method EnterTick { name } 
+    private method GetOverlappingMarkers { x y } 
+    private method GetScreenPosition { name } 
+    private method LeaveTick { name } 
+    private method SetRelativeValue  { name x }
+    private method GetRelativeValue  { name }
+    private method RemoveDuplicateMarkers {name x y} 
+    private method SetScreenPosition { name } 
+    private method SetVisibility { name bool } 
+    private method StartDrag { name x y } 
+    private method StopDrag { name x y } 
+    private method Activate { name } 
+    private method Deactivate { name } 
+    private method UpdateViewer {} 
+
+    constructor {c name args} {}
+    destructor {} 
+    public method limits { min max }
+    public method names {}
+    public method name {}
+    public method values {}
+    public method absoluteValues {}
+    public method removeMarkers { list }
+    public method addMarkers { values }
+    public method newMarker { x y state }
+    public method deleteMarker { x y }
+    public method hideMarkers { {list {}} }
+    public method showMarkers { {limits {}} }
+}
+
+itcl::body Rappture::TransferFunctionEditor::constructor {c name args} { 
+    set _canvas $c
+    set _name $name
+    set _limits [list 0.0 1.0] 
+    eval configure $args
+}
+
+itcl::body Rappture::TransferFunctionEditor::limits { min max } { 
+    set _limits [list $min $max]
+}
+
+itcl::body Rappture::TransferFunctionEditor::names {} { 
+    return [lsort [array names _values]]
+}
+
+itcl::body Rappture::TransferFunctionEditor::values {} { 
+    set list {}
+    foreach name [array names _ticks] {
+	lappend list [GetRelativeValue $name]
+    }
+    return [lsort -real $list]
+}
+
+itcl::body Rappture::TransferFunctionEditor::absoluteValues {} { 
+    set list {}
+    foreach name [array names _values] {
+	lappend list [GetAbsoluteValue $name]
+    }
+    return $list
+}
+
+itcl::body Rappture::TransferFunctionEditor::deleteMarker { x y } { 
+    foreach marker [GetOverlappingMarkers $x $y] {
+        $_canvas delete $_ticks($marker)
+        $_canvas delete $_labels($marker)
+        array unset _ticks $marker
+        array unset _labels $marker
+        array unset _values $marker
+        bell
+        UpdateViewer
+    }
+}
+
+itcl::body Rappture::TransferFunctionEditor::newMarker { x y state } { 
+    foreach id [$_canvas find overlapping \
+                    [expr $x-5] [expr $y-5] [expr $x+5] [expr $y+5]] {
+	if { [info exists _id2name($id)] } {
+            puts stderr "Too close to existing marker"
+	    return;                     # Too close to existing marker
+	}
+    }
+    set name "tick[incr _nextId]"
+    set w [winfo width $_canvas]
+    set h [winfo height $_canvas]
+
+    set _ticks($name) [$_canvas create image 0 $h \
+                           -image $_normalIcon -anchor s \
+                           -tags "tick $_name $this" -state $state]
+    set _labels($name) [$_canvas create text 0 $h \
+                            -anchor n -fill white -font "Helvetica 8" \
+                            -tags "labels $this $_name" -state $state]
+    set _id2name($_ticks($name)) $name
+    $_canvas bind $_ticks($name) <Enter> [itcl::code $this EnterTick $name]
+    $_canvas bind $_ticks($name) <Leave> [itcl::code $this LeaveTick $name]
+    $_canvas bind $_ticks($name) <ButtonPress-1> \
+	[itcl::code $this StartDrag $name %x %y]
+    $_canvas bind $_ticks($name) <B1-Motion> \
+	[itcl::code $this ContinueDrag $name %x %y]
+    $_canvas bind $_ticks($name) <ButtonRelease-1> \
+	[itcl::code $this StopDrag $name %x %y]
+
+    SetRelativeValue $name [expr {double($x-10)/($w-20)}]
+    if { $state == "normal" } {
+        UpdateViewer
+    }
+    return $name
+}
+
+itcl::body Rappture::TransferFunctionEditor::destructor {} {
+    $_canvas delete $_name
+}
+
+itcl::body Rappture::TransferFunctionEditor::name {} {
+    return $_name
+}
+
+itcl::body Rappture::TransferFunctionEditor::Activate { name } {
+    if  { $_activePress || $_activeMotion } {
+        $_canvas itemconfigure $_labels($name) -state normal
+        $_canvas itemconfigure $_ticks($name) -image $_activeIcon
+        $_canvas itemconfigure title -state hidden
+    }
+}
+
+itcl::body Rappture::TransferFunctionEditor::Deactivate { name } {
+    if  { $_activePress || $_activeMotion } {
+        #puts stderr "do nothing for Deactivate"
+    } else {
+        $_canvas itemconfigure $_labels($name) -state hidden
+        $_canvas itemconfigure $_ticks($name) -image $_normalIcon
+        $_canvas itemconfigure title -state normal
+    }
+}
+
+itcl::body Rappture::TransferFunctionEditor::SetVisibility { name bool } {
+    if { $bool } {
+        $_canvas itemconfigure $_ticks($name) -state normal
+        $_canvas raise $_ticks($name)
+    } else {
+        $_canvas itemconfigure $_ticks($name) -state hidden
+    }
+}
+
+itcl::body Rappture::TransferFunctionEditor::GetScreenPosition { name } { 
+    set x [GetRelativeValue $name]
+    if { $x < 0.0 } {
+        set x 0.0
+    } elseif { $x > 1.0 } {
+        set x 1.0 
+    }
+    set low 10 
+    set w [winfo width $_canvas]
+    set high [expr {$w  - 10}]
+    set x [expr {round($x*($high - $low) + $low)}]
+    return $x
+}
+
+itcl::body Rappture::TransferFunctionEditor::SetScreenPosition { name } { 
+    set value $_values($name)
+    set x [GetScreenPosition $name]
+    set absval [GetAbsoluteValue $name]
+    set y 31
+    $_canvas itemconfigure $_labels($name) -text [format %g $absval]
+    $_canvas coords $_ticks($name) $x [expr {$y+3}]
+    $_canvas coords $_labels($name) $x [expr {$y+5}]
+}
+
+itcl::body Rappture::TransferFunctionEditor::GetAbsoluteValue { name } {
+    foreach {min max} $_limits break
+    return [expr {($_values($name) * ($max - $min)) + $min}]
+}
+
+itcl::body Rappture::TransferFunctionEditor::SetAbsoluteValue { name value } {
+    foreach {min max} $_limits break
+    set absval $value
+    set relval [expr {($absval - $min) / ($max - $min)}]
+    set _values($name) $relval
+    set y 31
+    $_canvas itemconfigure $_label -text [format %g $absval]
+    set x [GetScreenPosition $name]
+    $_canvas coords $_ticks($name) $x [expr {$y+3}]
+    $_canvas coords $_labels($name) $x [expr {$y+5}]
+    return $absval
+}
+
+itcl::body Rappture::TransferFunctionEditor::GetRelativeValue  { name } {
+    return $_values($name)
+}
+
+itcl::body Rappture::TransferFunctionEditor::SetRelativeValue  { name value } {
+    set _values($name) $value
+    set x [GetScreenPosition $name]
+    set y 31
+    set absval [GetAbsoluteValue $name]
+    $_canvas itemconfigure $_labels($name) -text [format %g $absval]
+    $_canvas coords $_ticks($name) $x [expr {$y+3}]
+    $_canvas coords $_labels($name) $x [expr {$y+5}]
+}
+
+itcl::body Rappture::TransferFunctionEditor::EnterTick { name } {
+    set _activeMotion 1
+    Activate $name
+    $_canvas raise $_ticks($name)
+}
+
+itcl::body Rappture::TransferFunctionEditor::LeaveTick { name } {
+    set _activeMotion 0
+    Deactivate $name
+}
+
+itcl::body Rappture::TransferFunctionEditor::StartDrag { name x y } {
+    $_canvas raise $_ticks($name) 
+    set _activePress 1
+    Activate $name
+    $_canvas itemconfigure limits -state hidden
+    $_canvas itemconfigure title -state hidden
+}
+
+itcl::body Rappture::TransferFunctionEditor::StopDrag { name x y } {
+    ContinueDrag $name $x $y 
+    RemoveDuplicateMarkers $name $x $y
+    set _activePress 0
+    Deactivate $name
+    $_canvas itemconfigure limits -state normal
+    $_canvas itemconfigure title -state normal
+}
+
+itcl::body Rappture::TransferFunctionEditor::ContinueDrag { name x y } {
+    set w [winfo width $_canvas]
+    SetRelativeValue $name [expr {double($x-10)/($w-20)}]
+    UpdateViewer
+    $_canvas raise $_ticks($name)
+    set _activePress 1
+    Activate $name
+    $_canvas itemconfigure limits -state hidden
+    $_canvas itemconfigure title -state hidden
+}
+
+itcl::body Rappture::TransferFunctionEditor::GetOverlappingMarkers { x y } {
+    set list {}
+    foreach id [$_canvas find overlapping $x $y $x $y] {
+	if { [info exists _id2name($id)] } {
+	    lappend list $_id2name($id)
+	}
+    }
+    return $list
+}
+
+itcl::body Rappture::TransferFunctionEditor::hideMarkers { {list {}} } {
+    if { $list == "" } {
+	set list [array names _values]
+    }
+    foreach name $list {
+	SetVisibility $name 0
+    }
+}
+
+itcl::body Rappture::TransferFunctionEditor::showMarkers { {limits {}} } {
+    if { $limits != "" } {
+	set _limits $limits
+	foreach name [array names _values] {
+	    SetScreenPosition $name 
+	}
+    }
+    foreach name [array names _values] {
+	SetVisibility $name 1
+    }
+}
+
+itcl::body Rappture::TransferFunctionEditor::RemoveDuplicateMarkers {name x y} {
+    foreach marker [GetOverlappingMarkers $x $y] {
+	if { $marker != $name } {
+            Activate $marker 
+            set markerx [GetScreenPosition $marker]
+            if { ($x < ($markerx-3)) || ($x > ($markerx+3)) } {
+                continue
+            }
+	    $_canvas delete $_ticks($marker)
+	    $_canvas delete $_labels($marker)
+	    array unset _ticks $marker
+	    array unset _labels $marker
+	    array unset _values $marker
+            bell
+	}
+    }
+}
+
+itcl::body Rappture::TransferFunctionEditor::addMarkers { values } {
+    foreach value $values {
+	set name [newMarker 0 0 hidden]
+	SetRelativeValue $name $value
+    }
+}
+
+itcl::body Rappture::TransferFunctionEditor::removeMarkers { names } {
+    if { $names == "" } {
+	set names [array names _values]
+    }
+    foreach name $names {
+	$_canvas delete $_ticks($name)
+	$_canvas delete $_labels($name)
+	array unset _ticks $name
+	array unset _labels $name
+	array unset _values $name
+    }
+    UpdateViewer
+}
+
+itcl::body Rappture::TransferFunctionEditor::UpdateViewer {} {
+    # Tell the nanovis/flowvis client to update its transfer functions
+    # now that a marker position has changed.
+    if { $command != "" } {
+	eval uplevel \#0 $command
+    }
+}
